package com.hfkj.dao;

import com.hfkj.entity.GoodsLogistics;
import com.hfkj.entity.GoodsLogisticsExample.Criteria;
import com.hfkj.entity.GoodsLogisticsExample.Criterion;
import com.hfkj.entity.GoodsLogisticsExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class GoodsLogisticsSqlProvider {

    public String countByExample(GoodsLogisticsExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("goods_logistics");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(GoodsLogisticsExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("goods_logistics");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(GoodsLogistics record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("goods_logistics");
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getTaskNo() != null) {
            sql.VALUES("task_no", "#{taskNo,jdbcType=VARCHAR}");
        }
        
        if (record.getNumber() != null) {
            sql.VALUES("`number`", "#{number,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatus() != null) {
            sql.VALUES("logistics_status", "#{logisticsStatus,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatusDesc() != null) {
            sql.VALUES("logistics_status_desc", "#{logisticsStatusDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastMessage() != null) {
            sql.VALUES("the_last_message", "#{theLastMessage,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastTime() != null) {
            sql.VALUES("the_last_time", "#{theLastTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTakeTime() != null) {
            sql.VALUES("take_time", "#{takeTime,jdbcType=VARCHAR}");
        }
        
        if (record.getCourier() != null) {
            sql.VALUES("courier", "#{courier,jdbcType=VARCHAR}");
        }
        
        if (record.getCourierPhone() != null) {
            sql.VALUES("courier_phone", "#{courierPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsTraceDetails() != null) {
            sql.VALUES("logistics_trace_details", "#{logisticsTraceDetails,jdbcType=VARCHAR}");
        }
        
        if (record.getExpressCompanyName() != null) {
            sql.VALUES("express_company_name", "#{expressCompanyName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.VALUES("op_id", "#{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.VALUES("op_name", "#{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(GoodsLogisticsExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("user_id");
        sql.SELECT("order_id");
        sql.SELECT("task_no");
        sql.SELECT("`number`");
        sql.SELECT("logistics_status");
        sql.SELECT("logistics_status_desc");
        sql.SELECT("the_last_message");
        sql.SELECT("the_last_time");
        sql.SELECT("take_time");
        sql.SELECT("courier");
        sql.SELECT("courier_phone");
        sql.SELECT("logistics_trace_details");
        sql.SELECT("express_company_name");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("op_id");
        sql.SELECT("op_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("goods_logistics");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        GoodsLogistics record = (GoodsLogistics) parameter.get("record");
        GoodsLogisticsExample example = (GoodsLogisticsExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("goods_logistics");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getTaskNo() != null) {
            sql.SET("task_no = #{record.taskNo,jdbcType=VARCHAR}");
        }
        
        if (record.getNumber() != null) {
            sql.SET("`number` = #{record.number,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatus() != null) {
            sql.SET("logistics_status = #{record.logisticsStatus,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatusDesc() != null) {
            sql.SET("logistics_status_desc = #{record.logisticsStatusDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastMessage() != null) {
            sql.SET("the_last_message = #{record.theLastMessage,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastTime() != null) {
            sql.SET("the_last_time = #{record.theLastTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTakeTime() != null) {
            sql.SET("take_time = #{record.takeTime,jdbcType=VARCHAR}");
        }
        
        if (record.getCourier() != null) {
            sql.SET("courier = #{record.courier,jdbcType=VARCHAR}");
        }
        
        if (record.getCourierPhone() != null) {
            sql.SET("courier_phone = #{record.courierPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsTraceDetails() != null) {
            sql.SET("logistics_trace_details = #{record.logisticsTraceDetails,jdbcType=VARCHAR}");
        }
        
        if (record.getExpressCompanyName() != null) {
            sql.SET("express_company_name = #{record.expressCompanyName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("goods_logistics");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("task_no = #{record.taskNo,jdbcType=VARCHAR}");
        sql.SET("`number` = #{record.number,jdbcType=VARCHAR}");
        sql.SET("logistics_status = #{record.logisticsStatus,jdbcType=VARCHAR}");
        sql.SET("logistics_status_desc = #{record.logisticsStatusDesc,jdbcType=VARCHAR}");
        sql.SET("the_last_message = #{record.theLastMessage,jdbcType=VARCHAR}");
        sql.SET("the_last_time = #{record.theLastTime,jdbcType=TIMESTAMP}");
        sql.SET("take_time = #{record.takeTime,jdbcType=VARCHAR}");
        sql.SET("courier = #{record.courier,jdbcType=VARCHAR}");
        sql.SET("courier_phone = #{record.courierPhone,jdbcType=VARCHAR}");
        sql.SET("logistics_trace_details = #{record.logisticsTraceDetails,jdbcType=VARCHAR}");
        sql.SET("express_company_name = #{record.expressCompanyName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        GoodsLogisticsExample example = (GoodsLogisticsExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(GoodsLogistics record) {
        SQL sql = new SQL();
        sql.UPDATE("goods_logistics");
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getTaskNo() != null) {
            sql.SET("task_no = #{taskNo,jdbcType=VARCHAR}");
        }
        
        if (record.getNumber() != null) {
            sql.SET("`number` = #{number,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatus() != null) {
            sql.SET("logistics_status = #{logisticsStatus,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsStatusDesc() != null) {
            sql.SET("logistics_status_desc = #{logisticsStatusDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastMessage() != null) {
            sql.SET("the_last_message = #{theLastMessage,jdbcType=VARCHAR}");
        }
        
        if (record.getTheLastTime() != null) {
            sql.SET("the_last_time = #{theLastTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getTakeTime() != null) {
            sql.SET("take_time = #{takeTime,jdbcType=VARCHAR}");
        }
        
        if (record.getCourier() != null) {
            sql.SET("courier = #{courier,jdbcType=VARCHAR}");
        }
        
        if (record.getCourierPhone() != null) {
            sql.SET("courier_phone = #{courierPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getLogisticsTraceDetails() != null) {
            sql.SET("logistics_trace_details = #{logisticsTraceDetails,jdbcType=VARCHAR}");
        }
        
        if (record.getExpressCompanyName() != null) {
            sql.SET("express_company_name = #{expressCompanyName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, GoodsLogisticsExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}